#line 1 "D:/Rev.0 In C/OnewireToVoltageConverterInC.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic/include/built_in.h"
#line 33 "D:/Rev.0 In C/OnewireToVoltageConverterInC.c"
unsigned short TempByte;
signed int Input1;
signed int Input2;
unsigned int Output1;
unsigned int Output2;
unsigned short CycleCounter;
char txt[7];

const unsigned int FailureFallbackVoltage = 0;

void InitTimer1(){
 T1CON = 1;
 TMR1IF_bit = 0;
 TMR1H = 0x63;
 TMR1L = 0xC0;
 TMR1IE_bit = 1;
 PEIE_bit = 1;
 GIE_bit = 1;
}

void InitPWM2(){
 PWM2CLKCON = 0;
 PWM2LDM_bit = 0;
 PWM2CON = 0;
 PWM2DCH = 0;
 PWM2DCL = 0;
 PWM2PHH = 0;
 PWM2PHL = 0;
 PWM2OFH = 0;
 PWM2OFL = 0;
 PWM2PRH = 0x03;
 PWM2PRL = 0xE8;
}

void InitPWM3(){
 PWM3CLKCON = 0;
 PWM3LDM_bit = 0;
 PWM3CON = 0;
 PWM3DCH = 0;
 PWM3DCL = 0;
 PWM3PHH = 0;
 PWM3PHL = 0;
 PWM3OFH = 0;
 PWM3OFL = 0;
 PWM3PRH = 0x03;;
 PWM3PRL = 0xE8;
}

void InitHardware(){
 ANSELA = 0b00000000;
 PORTA = 0b00000000;
 TRISA = 0b11001010;








 OSCCON = 0b01111011;
 InitTimer1();

 InitPWM2();
 InitPWM3();
}

void StartReadInput1(){
 Ow_Reset(&PortA, 4);
 Ow_Write(&PortA, 4, 0xCC);
 Ow_Write(&PortA, 4, 0x44);
}

void StartReadInput2(){
 Ow_Reset(&PortA, 5);
 Ow_Write(&PortA, 5, 0xCC);
 Ow_Write(&PortA, 5, 0x44);
}

void GetInput1(){
 if (Ow_Reset(&PortA, 4) == 0){
 Ow_Write(&PortA, 4, 0xCC);
 Ow_Write(&PortA, 4, 0xBE);
  ((char *)&Input1)[0]  = Ow_Read(&PORTA, 4);
  ((char *)&Input1)[1]  = Ow_Read(&PORTA, 4);
 Input1 = (Input1 * 10) / 16 ;
 TempByte = Ow_Read(&PortA, 4);
 TempByte = Ow_Read(&PortA, 4);
 TempByte = Ow_Read(&PortA, 4);

 if (TempByte == 0){
 Input1 = 9999;
 }
 }
 else{
 Input1 = 9999;
 }
}

void GetInput2(){
 if (Ow_Reset(&PortA, 5) == 0){
 Ow_Write(&PortA, 5, 0xCC);
 Ow_Write(&PortA, 5, 0xBE);
  ((char *)&Input2)[0]  = Ow_Read(&PORTA, 5);
  ((char *)&Input2)[1]  = Ow_Read(&PORTA, 5);
 Input2 = (Input2 * 10) / 16 ;
 TempByte = Ow_Read(&PortA, 5);
 TempByte = Ow_Read(&PortA, 5);
 TempByte = Ow_Read(&PortA, 5);

 if (TempByte == 0){
 Input2 = 9999;
 }
 }
 else{
 Input2 = 9999;
 }
}

signed int ScaleOut(signed int InputValue){
 if(InputValue == 9999){
 return(FailureFallbackVoltage);
 }

 if (InputValue < -200){
 InputValue = -200;
 }

 if (InputValue > +800){
 InputValue = 800;
 }

 return( InputValue + 200);
}

void Set_PWM2(){
 PWM2DCH =  ((char *)&Output1)[1] ;
 PWM2DCL =  ((char *)&Output1)[0] ;
 PWM2LD_bit = 1;
 PWM2OE_bit = 1;
 PWM2EN_bit = 1;
}

void Set_PWM3(){
 PWM3DCH =  ((char *)&Output2)[1] ;
 PWM3DCL =  ((char *)&Output2)[0] ;
 PWM3LD_bit = 1;
 PWM3OE_bit = 1;
 PWM3EN_bit = 1;
}

void interrupt(){
 if (TMR1IF_bit){
 TMR1IF_bit = 0;
 TMR1H = 0x63;
 TMR1L = 0xC0;
 CycleCounter ++;
 }
}

void main() {
 InitHardware();
 CycleCounter = 0;
 while (1) {
 if (CycleCounter == 10){
 StartReadInput1();
 StartReadInput2();
 }

 if (CycleCounter == 100){
 GetInput1();
 Output1 = ScaleOut(Input1);

 GetInput2();
 Output2 = ScaleOut(Input2);

 if (PortA.B3 == 1){
 Output1 = 750;
 Output2 = 750;
 }

 Set_PWM2();
 Set_PWM3();

 CycleCounter = 0;
 }

 asm CLRWDT;
 }

}
